export const hexToRgba = (hex: string): { r: number; g: number; b: number; a: number } => {
  // remove the hash at the start if it is there
  hex = hex.replace("#", "");

  let r, g, b, a;

  if (hex.length === 8) {
    // hex have alpha (rrggbbaa)
    r = parseInt(hex.substring(0, 2), 16);
    g = parseInt(hex.substring(2, 4), 16);
    b = parseInt(hex.substring(4, 6), 16);
    // convert alpha (from 0-255) to decimal (from 0-1)
    a = parseInt(hex.substring(6, 8), 16) / 255;
  } else if (hex.length === 6) {
    // hex no have alpha
    r = parseInt(hex.substring(0, 2), 16);
    g = parseInt(hex.substring(2, 4), 16);
    b = parseInt(hex.substring(4, 6), 16);
    // default alpha is 1
    a = 1;
  } else {
    throw new Error("Invalid hex color format. Must be #rrggbbaa or #rrggbb.");
  }

  return { r, g, b, a };
};
